searchNodes=[{"doc":"Elixir Implementation of the purl (package url) specification. Specification https://github.com/package-url/purl-spec Format : pkg:type/namespace/name@version?qualifiers#subpath License A lot of the documentation was taken directly from the specification. It is licensed under the MIT License: Copyright ( c ) the purl authors Permission is hereby granted , free of charge , to any person obtaining a copy of this software and associated documentation files ( the &quot;Software&quot; ) , to deal in the Software without restriction , including without limitation the rights to use , copy , modify , merge , publish , distribute , sublicense , and / or sell copies of the Software , and to permit persons to whom the Software is furnished to do so , subject to the following conditions : The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software . THE SOFTWARE IS PROVIDED &quot;AS IS&quot; , WITHOUT WARRANTY OF ANY KIND , EXPRESS OR IMPLIED , INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY , FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT . IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM , DAMAGES OR OTHER LIABILITY , WHETHER IN AN ACTION OF CONTRACT , TORT OR OTHERWISE , ARISING FROM , OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE .","ref":"Purl.html","title":"Purl","type":"module"},{"doc":"Convert known URLs to purl Currently Supported GitHub: Repository HTTP / Git URL, Project URL BitBucket: Repository HTTTP / Git URL, Project URL Hex.pm package URL","ref":"Purl.html#from_resource_uri/1","title":"Purl.from_resource_uri/1","type":"function"},{"doc":"Creates a new purl struct from a Purl , URI or string. Examples iex&gt; Purl . new ( &quot;pkg:hex/purl&quot; ) { :ok , % Purl { type : &quot;hex&quot; , name : &quot;purl&quot; } }","ref":"Purl.html#new/1","title":"Purl.new/1","type":"function"},{"doc":"Similar to new/1 but raises URI.Error , Purl.Error.InvalidField or Purl.Error.InvalidURI if an invalid input is given. Examples iex&gt; Purl . new! ( &quot;pkg:hex/purl&quot; ) % Purl { type : &quot;hex&quot; , name : &quot;purl&quot; } iex&gt; Purl . new! ( &quot;&gt;pkg:hex/purl&quot; ) ** (URI.Error) cannot parse due to reason invalid_uri: &quot;&gt;&quot; iex&gt; Purl . new! ( &quot;pkg:hex*/purl&quot; ) ** (Purl.Error.InvalidField) invalid field type, &quot;hex*&quot; given","ref":"Purl.html#new!/1","title":"Purl.new!/1","type":"function"},{"doc":"Formats purl as string Examples iex&gt; Purl . to_string ( % Purl { type : &quot;hex&quot; , name : &quot;purl&quot; } ) &quot;pkg:hex/purl&quot;","ref":"Purl.html#to_string/1","title":"Purl.to_string/1","type":"function"},{"doc":"Converts a purl to a URI Examples iex&gt; Purl . to_uri ( % Purl { type : &quot;hex&quot; , name : &quot;purl&quot; } ) % URI { scheme : &quot;pkg&quot; , path : &quot;hex/purl&quot; }","ref":"Purl.html#to_uri/1","title":"Purl.to_uri/1","type":"function"},{"doc":"the name of the package","ref":"Purl.html#t:name/0","title":"Purl.name/0","type":"type"},{"doc":"some name prefix such as a Maven groupid, a Docker image owner, a GitHub user or organization The values are type-specific.","ref":"Purl.html#t:namespace/0","title":"Purl.namespace/0","type":"type"},{"doc":"Segment of the namespace Validation must not contain a '/' must not be empty A URL host or Authority must NOT be used as a namespace. Use instead a repository_url qualifier. Note however that for some types, the namespace may look like a host.","ref":"Purl.html#t:namespace_segment/0","title":"Purl.namespace_segment/0","type":"type"},{"doc":"","ref":"Purl.html#t:parse_error/0","title":"Purl.parse_error/0","type":"type"},{"doc":"qualifier key Validation The key must be composed only of ASCII letters and numbers, '.', '-' and '_' (period, dash and underscore) A key cannot start with a number A key must NOT be percent-encoded A key is case insensitive. The canonical form is lowercase A key cannot contains spaces","ref":"Purl.html#t:qualifier_key/0","title":"Purl.qualifier_key/0","type":"type"},{"doc":"qualifier value Validation value cannot be an empty string: a key=value pair with an empty value is the same as no key/value at all for this key","ref":"Purl.html#t:qualifier_value/0","title":"Purl.qualifier_value/0","type":"type"},{"doc":"extra qualifying data for a package such as an OS, architecture, a distro, etc. The values are type-specific. Validation key must be unique within the keys of the qualifiers string","ref":"Purl.html#t:qualifiers/0","title":"Purl.qualifiers/0","type":"type"},{"doc":"extra subpath within a package, relative to the package root","ref":"Purl.html#t:subpath/0","title":"Purl.subpath/0","type":"type"},{"doc":"subpath segment Validation must not contain a '/' must not be any of '..' or '.' must not be empty","ref":"Purl.html#t:subpath_segment/0","title":"Purl.subpath_segment/0","type":"type"},{"doc":"Package URL struct","ref":"Purl.html#t:t/0","title":"Purl.t/0","type":"type"},{"doc":"the package &quot;type&quot; or package &quot;protocol&quot; such as maven , npm , nuget , gem , pypi , etc. Known types: https://github.com/package-url/purl-spec/blob/master/PURL-TYPES.rst Validation The package type is composed only of ASCII letters and numbers, '.', '+' and '-' (period, plus, and dash) The type cannot start with a number The type cannot contains spaces The type must NOT be percent-encoded The type is case insensitive. The canonical form is lowercase","ref":"Purl.html#t:type/0","title":"Purl.type/0","type":"type"},{"doc":"the version of the package A version is a plain and opaque string. Some package types use versioning conventions such as semver for NPMs or nevra conventions for RPMS. A type may define a procedure to compare and sort versions, but there is no reliable and uniform way to do such comparison consistently.","ref":"Purl.html#t:version/0","title":"Purl.version/0","type":"type"},{"doc":"Error raised if qualifier keys are duplicated","ref":"Purl.Error.DuplicateQualifier.html","title":"Purl.Error.DuplicateQualifier","type":"exception"},{"doc":"","ref":"Purl.Error.DuplicateQualifier.html#t:t/0","title":"Purl.Error.DuplicateQualifier.t/0","type":"type"},{"doc":"Error raised in field values are invalid","ref":"Purl.Error.InvalidField.html","title":"Purl.Error.InvalidField","type":"exception"},{"doc":"","ref":"Purl.Error.InvalidField.html#t:t/0","title":"Purl.Error.InvalidField.t/0","type":"type"},{"doc":"Error raised if the scheme of the purl is incorrect","ref":"Purl.Error.InvalidScheme.html","title":"Purl.Error.InvalidScheme","type":"exception"},{"doc":"","ref":"Purl.Error.InvalidScheme.html#t:t/0","title":"Purl.Error.InvalidScheme.t/0","type":"type"},{"doc":"Error raised if special rules for type are not fulfilled","ref":"Purl.Error.SpecialCaseFailed.html","title":"Purl.Error.SpecialCaseFailed","type":"exception"},{"doc":"","ref":"Purl.Error.SpecialCaseFailed.html#t:t/0","title":"Purl.Error.SpecialCaseFailed.t/0","type":"type"},{"doc":"Implementation of the purl (package url) specification. See the documentation .","ref":"readme.html","title":"Purl","type":"extras"},{"doc":"iex&gt; Purl . new ( &quot;pkg:hex/purl&quot; ) { :ok , % Purl { type : &quot;hex&quot; , name : &quot;purl&quot; } } iex&gt; Purl . to_string ( % Purl { type : &quot;hex&quot; , name : &quot;purl&quot; } ) &quot;pkg:hex/purl&quot;","ref":"readme.html#usage","title":"Purl - Usage","type":"extras"},{"doc":"The package can be installed by adding purl to your list of dependencies in mix.exs : def deps do [ { :purl , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Purl - Installation","type":"extras"},{"doc":"Copyright 2023 JOSHMARTIN GmbH Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at: http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"Purl - License","type":"extras"}]